package net.ihe.gazelle.proxy.listeners;

import net.ihe.gazelle.proxy.model.message.HL7Message;
import net.ihe.gazelle.proxy.netty.channel.ProxySide;

public class HL7EventListener extends SameEventListener<String> {

	public HL7EventListener(MessageListener messageListener) {
		super(messageListener);
	}

	protected void saveMessage(String message, String requesterIp, int requesterPort, int proxyPort,
			String responderIp, int responderPort, int requestChannelId, int responseChannelId, ProxySide side) {
		// Messages are coming from different threads!
		synchronized (this) {
			HL7Message hl7message = new HL7Message(requesterIp, requesterPort, proxyPort, responderIp, responderPort,
					requestChannelId, responseChannelId, side);
			hl7message.setMessageReceivedAsString(message);

			messageListener.processMessage(hl7message);
		}
	}
}
