package net.ihe.gazelle.proxy.listeners;

import javax.persistence.EntityManager;

import net.ihe.gazelle.proxy.model.message.AbstractMessage;

public abstract class MessageListenerSaveAbstract implements MessageListener {

	@Override
	public void processMessage(EntityManager em, AbstractMessage abstractMessage) {
		if (abstractMessage.getId() == null) {
			em.persist(abstractMessage);
		} else {
			em.merge(abstractMessage);
		}
	}

	@Override
	public void processMessage(AbstractMessage abstractMessage) {
		EntityManager em = getEntityManager();
		processMessage(em, abstractMessage);
		releaseEntityManager(em);
	}

}
