package net.ihe.gazelle.proxy.listeners;

import net.ihe.gazelle.proxy.model.message.RawMessage;
import net.ihe.gazelle.proxy.netty.channel.ProxySide;

public class RawEventListener extends SameEventListener<byte[]> {

	public RawEventListener(MessageListener messageListener) {
		super(messageListener);
	}

	protected void saveMessage(byte[] message, String requesterIp, int requesterPort, int proxyPort,
			String responderIp, int responderPort,  int requestChannelId,  int responseChannelId, ProxySide side) {
		// Messages are coming from different threads!
		synchronized (this) {
			RawMessage rawmessage = new RawMessage(requesterIp, requesterPort, proxyPort, responderIp, responderPort,
					requestChannelId, responseChannelId, side);
			rawmessage.setMessageReceived(message);

			messageListener.processMessage(rawmessage);
		}
	}

}
