package net.ihe.gazelle.proxy.netty.channel;

import net.ihe.gazelle.proxy.netty.Proxy;

import org.apache.log4j.Logger;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.MessageEvent;
import org.jboss.netty.channel.SimpleChannelUpstreamHandler;

public abstract class ProxyLogger<REQU, RESP> extends SimpleChannelUpstreamHandler {

	protected Proxy<REQU, RESP> proxy;
	protected ProxyHandler matchingHandler;

	private static Logger log = Logger.getLogger(ProxyLogger.class);

	public ProxyLogger(Proxy<REQU, RESP> proxy, ProxyHandler matchingHandler) {
		super();
		this.proxy = proxy;
		this.matchingHandler = matchingHandler;
	}

	@Override
	public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) throws Exception {
		final Object message = e.getMessage();
		try {
			new Thread(new Runnable() {
				public void run() {
					processMessage(message);
				}
			}).start();
		} catch (Throwable t) {
			log.error("Fail to handle request", t);
		}
	}

	protected abstract void processMessage(Object message);

}
