package net.ihe.gazelle.proxy.netty.protocols.dicom;

import java.io.IOException;

import jp.digitalsensation.ihej.transactionmonitor.dicom.messageexchange.Association;
import jp.digitalsensation.ihej.transactionmonitor.dicom.messageexchange.DimseMessage;
import jp.digitalsensation.ihej.transactionmonitor.dicom.messageexchange.DimseMessageParser;

import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.Channels;
import org.jboss.netty.channel.ExceptionEvent;
import org.jboss.netty.channel.MessageEvent;
import org.jboss.netty.channel.SimpleChannelUpstreamHandler;

public class DicomDecoder extends SimpleChannelUpstreamHandler {

	private DimseMessageParser dimseMessageParser;

	public DicomDecoder(String storageFolder) {
		super();
		try {
			dimseMessageParser = new DimseMessageParser(new Association(), storageFolder);
		} catch (IOException e) {
			throw new IllegalArgumentException(e);
		}
	}

	@Override
	public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) throws Exception {
		Object m = e.getMessage();
		if (!(m instanceof ChannelBuffer)) {
			ctx.sendUpstream(e);
			return;
		}

		ChannelBuffer input = (ChannelBuffer) m;
		if (!input.readable()) {
			return;
		}

		byte[] buf = new byte[input.readableBytes()];
		input.readBytes(buf);
		Iterable<DimseMessage> messages = dimseMessageParser.push(buf);
		for (DimseMessage dimseMessage : messages) {
			Channels.fireMessageReceived(ctx, dimseMessage);
		}
	}

	@Override
	public void exceptionCaught(ChannelHandlerContext ctx, ExceptionEvent e) throws Exception {
		ctx.sendUpstream(e);
	}

}
